<template>
  <div class="user-info">
    <h1>Información de Usuario</h1>
    <div class="details">
      <div class="image">
        <img :src="user.imageProfile" alt="Profile Image" />
      </div>
      <div class="map">
          <MapComponent :latitude="user.location.latitude" :longitude="user.location.longitude" />
      </div>
      <div class="favourite">
        <button @click="onAddToFavourites">
          <img :src="favouriteImage" alt="Favourite" />
        </button>
      </div>
    </div>
    <div class="personal-data">
      <div>{{ user.name }}</div>
      <div><a :href="mailto">{{ user.email }}</a></div>
    </div>
    <div class="location-data">
      <div><label>Localización:</label> {{ user.city }}, {{ user.street }}</div>
      <div><label>Teléfonos:</label> {{ user.phone }} - {{ user.cell}}</div>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.user-info {
  border: 1px solid #eeeeee;
  border-radius: 5px;
  margin: 20px auto;
  background-color: #f8f8f8;
  width: 500px;
  padding: 20px;
}
.details {
  display: flex;
  justify-content: center;
  align-items: center;
}
.map, .image, .favourite {
  flex-basis: auto;
  padding: 10px;
  text-align: center;
}
.map {
  width: 400px;
  height: 200px;
  margin-bottom: 20px;
}
.image {
  img {
    border-radius: 150px;
  }
}
.favourite {
  width: 100px;
  text-align: right;
  button {
    border: none;
    background: none;
    padding: 0px;
    cursor: pointer;
      img {
        width: 50px;
      }
  }
}
.location-data, .personal-data {
  margin: 10px;
  label {
    font-weight: bold;
  }
  a {
    color: #ff0000;
    &:hover {
      color: #232323;
    }
  }
}
</style>

<script>
import MapComponent from '../components/MapComponent.vue';

const FAVOURITE_IMAGE = {
  off: 'https://cdn0.iconfinder.com/data/icons/leto-most-searched-mix-2/64/_heart_like_favourite-512.png',
  on: 'https://cdn0.iconfinder.com/data/icons/round-ui-icons/512/heart_red.png',
};
export default {
  name: 'userInfo',
  components: {
    MapComponent,
  },
  data() {
    return {
      user: {
        id: null,
        imageProfile: '',
        name: '',
        email: '',
        city: '',
        street: '',
        location: {},
        phone: '',
        cell: '',
      },
      favouriteImage: FAVOURITE_IMAGE.off,
    };
  },
  computed: {
    mailto() {
      return `mailto: ${this.user.email}`;
    },
  },
  mounted() {
    const { user } = this.$route.params;

    if (!user) {
      this.$router.push({ name: 'Home' });
    } else {
      this.user.id = user.id;
      this.user.imageProfile = user.imageProfile;
      this.user.map = user.map;
      this.user.name = user.name;
      this.user.email = user.email;
      this.user.city = user.city;
      this.user.street = user.street;
      this.user.location = user.location;
      this.user.phone = user.phone;
      this.user.cell = user.cell;
      this.favouriteImage = this.$store.getters.isFavouriteUser(this.user.id)
        ? FAVOURITE_IMAGE.on : FAVOURITE_IMAGE.off;
    }
  },
  methods: {
    onAddToFavourites() {
      this.$store.dispatch('addUserToFavourites', this.user);
      this.favouriteImage = FAVOURITE_IMAGE[this.favouriteImage === FAVOURITE_IMAGE.off ? 'on' : 'off'];
    },
  },
};
</script>
